#include <stdlib.h>
#include <signal.h>
#include <i86.h>
#include <stddef.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/psinfo.h>
#include <sys/osinfo.h>
#include <sys/sched.h>
#include <sys/prfx.h>
#include <sys/fd.h>
#include <sys/types.h>
#include "struct.h"
#include "extern.h"

/****************************************************************************/
/*Function terminate()                                                      */
/*              This function is called when a terminate signal is          */
/*              sent to the driver.  This function will detach the          */
/*              device and the prefix.                                      */
/*     Parameters Passed : none                                             */
/****************************************************************************/
void terminate()
{
  int i;

  tmkselect(0);
  bcreset();
  qnx_proxy_detach(tmk_proxy);
  if (nTmkType == MRTX || nTmkType == MRTXI)
  {
    for (i = 0; i < mrtgetnrt(); ++i)
    {
      if (mrtgetnrt() <= 10)
        sprintf(devicenamert, "%s_rt%d", devicename, i);
      else
        sprintf(devicenamert, "%s_rt%02d", devicename, i);
      qnx_prefix_detach(devicenamert);
    }
  }
  if (!(nTmkType == MRTX || nTmkType == MRTXI))
    qnx_prefix_detach(devicename);
  qnx_device_detach(devno);
  tmkdone(0);
  exit(0);
}
